#include "mawk.h"
#include "num.h"

mawk_num_id_t mawk_num_id = MAWK_NUM_ID_INT;

/* convert a number to Int; Int is int */

Int mawk_d_to_I(mawk_num_t d)
{
	return (Int) d;
}

const char *mawk_num_print_spec(mawk_num_t d)
{
	if (d == NUM_INF)
		return "inf";
	if (d == -NUM_NAN)
		return "-nan";
	return NULL;
}

/* slow implementstion */
mawk_num_t mawk_num_pow(mawk_num_t x, mawk_num_t y)
{
	mawk_num_t a = 1;

	for(; y > 0; y--)
		a = a * x;
	return a;
}



mawk_num_t mawk_num_sqrt(mawk_num_t x)
{
	mawk_num_t old_guess, guess;
	if ((x == NUM_NAN) || (x == NUM_INF) || (x == 0))
		return x;
	if (x < 0)
		return NUM_NAN;

/* Babylonian method */
	guess = 1;
	old_guess = -1;
	while(abs(old_guess - guess) > 1) {
		old_guess = guess;
		guess = (guess + x/guess) / 2;
	}
	return guess;
}

